
#include <stdio.h>
#include <linux/rtc.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdarg.h>

int rtc_fd;

void rtc_setup()
{
    if ((rtc_fd = open("/dev/rtc", O_RDONLY)) < 0) {
      printf("Cant open /dev/rtc because %s", strerror(errno));
    } else {
      unsigned int irqp = 1024;
      if (ioctl(rtc_fd, RTC_IRQP_SET, irqp) < 0) {
	printf("Could not set proper irq frequency %u %s\n", irqp,
	       strerror(errno));
	close(rtc_fd);
	rtc_fd = -1;
      } else if (ioctl(rtc_fd, RTC_PIE_ON, 0) < 0) {
	/* variable only by the root */
	printf("Some Pie On (?) error with /dev/rtc\n");
	close(rtc_fd);
	rtc_fd = -1;
      } else
	printf("Using /dev/rtc as timer.\n");
    }
}

void rtc_sleep(int time){
  while (time > 0){
    unsigned long rtc_ts;
    if (read (rtc_fd, &rtc_ts, sizeof(rtc_ts)) <= 0)
      printf("Could not read /dev/rtc %s",strerror(errno));
    time--;
  }
}

int main()
{
  rtc_setup();
    rtc_sleep(1024*5);
    return 0;
}
