
#include <qapplication.h>
#include <qpushbutton.h>
#include <qcanvas.h>
#include <qpixmap.h>

#define GFX_DONTSHRINK
#include "../common/nsmtracker.h"
#include "../common/windows_proc.h"

#include "../common/visual_proc.h"

#define INITIALPOOLSIZE 64

class RPoints{
public:
  RPoints();
  ~RPoints();

  void addPoint(int x,int y);
  void drawPoints(QPainter *qp);

private:
  QPointArray *qpa;
  uint num_points;
};

class MyWidget : public QWidget
{
public:
  MyWidget(struct Tracker_Windows *window, QWidget *parent=0, const char *name=0 );
  ~MyWidget();

    QColor     colors[8];				// color array
    RPoints    *rpoints[8];
    QPixmap    *qpixmap;
    QPixmap    *cursorpixmap;

    void timerEvent(QTimerEvent *);

protected:
    //    bool        event(QEvent *);
    void	paintEvent( QPaintEvent * );
    void        keyPressEvent(QKeyEvent *);
    void        keyReleaseEvent(QKeyEvent *qkeyevent);
    void	mousePressEvent( QMouseEvent *);
    void	mouseReleaseEvent( QMouseEvent *);
    void	mouseMoveEvent( QMouseEvent *);
    void        resizeEvent( QResizeEvent *);
    void        closeEvent(QCloseEvent *);
private:
    QPoint     *points;				// point array

    int		count;				// count = number of points
    bool	down;				// TRUE if mouse down

    struct Tracker_Windows *window;
};

